
package body Intervals is

  function IsNumeric(S: Interval) return Boolean is
  begin
    return False;
  end IsNumeric;

  function Scal(K: Integer) return Interval is
  begin
    return (Rep(K),Zero);
  end Scal;

  function Scal(R: Rep) return Interval is
  begin
    return (R,Zero);
  end Scal;

  function Ball(R: Rep) return Interval is
  begin
    return (Zero,Abs(R));
  end Ball;

  function Err0(S: Interval) return Boolean is
  begin
    return S.R=Zero;
  end Err0;

  function Approx(S: Interval) return Rep is
  begin
    return S.C;
  end Approx;

  function "-"(S: Interval) return Interval is
  begin
    return (-S.C,S.R);
  end "-";

  function Center(S: Interval) return Interval is
  begin
    return (S.C,Zero);
  end Center;

  procedure ResetCenter(S: in out Interval) is
  begin
    S.C := Zero;
  end ResetCenter;

  function ResetCenter(S: Interval) return Interval is
  begin
    return (Zero,S.R);
  end ResetCenter;

  procedure Split(S: in Interval; S0,SE: out Interval) is
  begin
    S0.C := S.C;
    S0.R := Zero;
    SE.C := Zero;
    SE.R := S.R;
  end Split;

end Intervals;
