with Reps, Messages, Fouriers_Init;
use Reps, Messages, Fouriers_Init;
with Intervals, Intervals.Ops, Intervals.IO;
use Intervals, Intervals.Ops, Intervals.IO;
with Fouriers, Fouriers.IO;

procedure ShowH is

  subtype Scalar is Interval;

  Lmax: constant Positive := 60;
  Wmax: constant Positive := 50;
  Pdeg: constant Positive := 22;
  Dho:  constant Natural  :=  8;

  package Scal_Fou is new Fouriers (Lmax => Lmax, Wmax => Wmax, Pdeg => Pdeg, Dho => Dho, Scalar => Scalar);
  package Scal_Fou_IO is new Scal_Fou.IO;
  use Scal_Fou, Scal_Fou_IO;

  Iname: constant String  := GetArg(1);  -- file name
  Itype: constant String  := GetArg(2);  -- data type (Dec/Hex)
  J:     constant Integer := GetArg(3);  -- parity (0/1)
  Cut:   constant Rep     := GetArg(4);  -- Cutoff

  H: Fourier;

begin
  Show("");
  Read(Iname,J,(Two,One),H,Itype(1)='D');
  Show("");
  Show(H,Cut);
  Show("");
end ShowH;
