with Ada.Text_IO;
use Ada.Text_IO;

pragma Elaborate_All(Ada.Text_IO);

generic

  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;

package Taylors.IO is

  procedure Show(P: in Taylor; Cut: in Rep := Zero);
  procedure Get(R: in Radius; F: in File_Type; P: out Taylor; IsPoly: in out Boolean;
                GetPoly: in Boolean; Decimal: in Boolean := True);
  procedure Put(F: in File_Type; P: in Taylor;
                PutPoly: in Boolean; Decimal: in Boolean := True);

end Taylors.IO;
